/*========================================================================================================================
	
	----------------------------------------
	-*- [ZP] Addon : Frags Progress Bar -*-
	----------------------------------------
	
	-----------------
	- Description -
	-----------------
	
	- This plugin adds an extra server tool to zombie plague mode, it's called Frags Progress Bar. 
	- This bar will fill a little bit for each kill but it will also evacuate if the time between frags is more than x seconds 
	- For example if you kill a zombie it will encrease to 12% and if you kill the second one before the x seconds expire it will encrease also to 25 % until it reaches 100 % 
	- But if you stop killing zombies and the x seconds had expired, the progress will decreas to 0 % . ( x seconds are 8 by default, but you can change them in cvars)
	- If you complete the progress you will receive a certain amont of ammo packs and you can aslo change them in cvars ( 100 by default) 
	
	---------
	- Notes -
	---------
	
	- Progress bar is not available for zombies . 
	- Progress bar is always available for humans . 
	- Progress bar can be available for : nemesis, survivor, sniper, assassin.
	- Progress bar will be really hard to complete it you set the x seconds to less than 5 seconds unless if the health of zombies are low . 
	- Unfortunately Bar length is not changeable .
	* Maybe in next version I will include levels, the ability to change the bar length by cvars, and mode cvars . 
	* last thing : the code of this plugin is stupid but at least it meets with the description ... 
	---------
	- Cvars -
	---------
	
	- duration_to_decrease_the_bar : 8.0
		The duration before the progress begin to decrease .
		
	- enable_nemesis_pbar : 0 
		enable/disable progress bar with nemesis .
		
	- enable_survivor_pbar : 0 
		enable/disable progress bar with survivor .
		
	- ammo_packs_earned : 100 
		ammount of ammo packs that player can obtain when he completes the progress 100 %.
		
	- x_position : -0.1 
		Position of the HUD Progress Bar on the X-axis .
		
	- y_position : 0.35 
		Position of the HUD Progress Bar on the Y-axis .
		
========================================================================================================================*/
	

  
#define PLUGIN "[ZP] Addon : Frags Progress Bar"
#define VERSION "1.0"
#define AUTHOR "A.Madjid"


#include <amxmodx>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombieplague>




new g_add_kill[33], g_times[33]
new Float:time0[33]
new Float:time1[33]
new Float:time2[33]
new Float:time3[33]
new Float:time4[33]
new Float:time5[33]
new Float:time6[33]

new duration, survivor, nemesis, ammo_packs, x, y

new const complete_progress_sound[] = "zombie_plague/Complete2.wav"

public plugin_precache	( )
{
engfunc(EngFunc_PrecacheSound, complete_progress_sound)
}
public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_event ( "HLTV", "event_round_start", "a", "1=0", "2=0" )
	register_event("DeathMsg", "player_die", "a") 
	RegisterHam(Ham_Player_PreThink, "player", "fw_Player_PreThink")
	duration = register_cvar("duration_to_decrease_the_bar", "8.0") 
	nemesis = register_cvar("enable_nemesis_pbar", "0") 
	survivor = register_cvar("enable_survivor_pbar", "0") 
	ammo_packs = register_cvar("ammo_packs_earned", "100")
	x = register_cvar("x_position", "-1.0") //Position of the HUD Progress Bar on the X-axis
	y = register_cvar("y_position", "0.35") //Position of the HUD Progress Bar on the Y-axis
	
}
public event_round_start(id) 
{
	g_add_kill[id] = 0
	g_times[id] = 0 
	hud(id)
	show_hudmessage(id, "0/8 Kills ^n[................................] 0%%")
}
public zp_round_started(mode, id) 
{ 
	if((mode == MODE_NEMESIS && get_pcvar_num(nemesis) == 0 ) || (mode == MODE_SURVIVOR && get_pcvar_num(survivor) == 0 ) || (mode == MODE_SWARM && zp_get_user_zombie(id)) || (mode == MODE_PLAGUE && zp_get_user_zombie(id)) || (zp_get_user_zombie(id)))
	{
		hud(id)
		show_hudmessage(id, "")
	}
}
public player_die() 
{
	new id = read_data(1)
	new id2 = read_data(2) 
	g_add_kill[id2] = 0
	g_times[id2] = 0 
	if (is_user_alive(id)) 
	{	
		if (!zp_get_user_zombie(id) || (MODE_NEMESIS && get_pcvar_num(nemesis) == 1) || (MODE_SURVIVOR && get_pcvar_num(survivor) == 1))
		{
			time0[id] = get_gametime()
			set_task(0.1, "add1",id) 
			set_task(0.2, "add2",id) 
			set_task(0.3, "add3",id) 
			set_task(0.4, "add4",id) 
			g_times[id] = 0 
			g_add_kill[id]++
			if ( g_add_kill[id] == 2 ) 
			{
				set_task(0.1, "add5",id) 
				set_task(0.2, "add6",id) 
				set_task(0.3, "add7",id) 
				set_task(0.4, "add8",id) 
				g_times[id] = 0 
				time1[id] = get_gametime()
			}	
			if ( g_add_kill[id] == 3 ) 
			{
				set_task(0.1, "add9",id) 
				set_task(0.2, "add10",id) 
				set_task(0.3, "add11",id) 
				set_task(0.4, "add12",id) 
				g_times[id] = 0 
				time2[id] = get_gametime()
			}
			if ( g_add_kill[id] == 4 ) 
			{
				set_task(0.1, "add13",id) 
				set_task(0.2, "add14",id) 
				set_task(0.3, "add15",id) 
				set_task(0.4, "add16",id) 
				g_times[id] = 0 
				time3[id] = get_gametime()
			}
			if ( g_add_kill[id] == 5 ) 
			{
				set_task(0.1, "add17",id) 
				set_task(0.2, "add18",id) 
				set_task(0.3, "add19",id) 
				set_task(0.4, "add20",id) 
				g_times[id] = 0 
				time4[id] = get_gametime()
			}
			if ( g_add_kill[id] == 6 ) 
			{
				set_task(0.1, "add21",id) 
				set_task(0.2, "add22",id) 
				set_task(0.3, "add23",id) 
				set_task(0.4, "add24",id) 
				g_times[id] = 0 
				time5[id] = get_gametime()
			}
			if ( g_add_kill[id] == 7) 
			{
				set_task(0.1, "add25",id) 
				set_task(0.2, "add26",id) 
				set_task(0.3, "add27",id) 
				set_task(0.4, "add28",id) 
				g_times[id] = 0 
				time6[id] = get_gametime()
			}
			if ( g_add_kill[id] == 8 ) 
			{
				set_task(0.1, "add29",id) 
				set_task(0.2, "add30",id) 
				set_task(0.3, "add31",id) 
				set_task(0.4, "add32",id) 
				g_add_kill[id] = 0
				g_times[id] = 0 
			}
			fw_Player_PreThink(id)
		}
		
		
	}	
} 
public fw_Player_PreThink(id)
{
	if((g_add_kill[id] ==1) && (get_gametime() - time0[id] > get_pcvar_float(duration) ) && (g_times[id] == 0)) 
	{
		set_task(0.1, "add4",id) 
		set_task(0.2, "add3",id) 
		set_task(0.3, "add2",id) 
		set_task(0.4, "add1",id)
		set_task(0.5, "add0",id)
		g_add_kill[id] = 0 
		g_times[id]++ 
	}
	if((g_add_kill[id] ==2) && (get_gametime() - time1[id] > get_pcvar_float(duration) ) && (g_times[id] == 0)) 
	{
		set_task(0.1, "add8",id) 
		set_task(0.2, "add7",id) 
		set_task(0.3, "add6",id) 
		set_task(0.4, "add5",id)
		set_task(0.5, "add4",id) 
		set_task(0.6, "add3",id) 
		set_task(0.7, "add2",id) 
		set_task(0.8, "add1",id)
		set_task(0.9, "add0",id)
		g_add_kill[id] = 0 
		g_times[id]++ 
	}
	if ((g_add_kill[id] == 3) && (get_gametime() - time2[id] > get_pcvar_float(duration) ) && (g_times[id] == 0) ) 
	{
		set_task(0.1, "add12",id) 
		set_task(0.2, "add11",id) 
		set_task(0.3, "add10",id) 
		set_task(0.4, "add9",id) 
		set_task(0.5, "add8",id)
		set_task(0.6, "add7",id) 
		set_task(0.7, "add6",id) 
		set_task(0.8, "add5",id) 
		set_task(0.9, "add4",id) 
		set_task(1.0, "add3",id)
		set_task(1.1, "add2",id) 
		set_task(1.2, "add1",id) 
		set_task(1.3, "add0",id)
		g_add_kill[id] = 0
		g_times[id]++ 
	}
	if ((g_add_kill[id] == 4) && (get_gametime() - time3[id] > get_pcvar_float(duration) ) && (g_times[id] == 0) ) 
	{
		set_task(0.1, "add16",id) 
		set_task(0.2, "add15",id) 
		set_task(0.3, "add14",id) 
		set_task(0.4, "add13",id) 
		set_task(0.5, "add12",id)
		set_task(0.6, "add11",id) 
		set_task(0.7, "add10",id) 
		set_task(0.8, "add9",id) 
		set_task(0.9, "add8",id) 
		set_task(1.0, "add7",id)
		set_task(1.1, "add6",id) 
		set_task(1.2, "add5",id) 
		set_task(1.3, "add4",id)
		set_task(1.4, "add3",id)
		set_task(1.5, "add2",id)
		set_task(1.6, "add1",id)
		set_task(1.7, "add0",id)
		g_add_kill[id] = 0
		g_times[id]++ 
	}
	if ((g_add_kill[id] == 5) && (get_gametime() - time4[id] > get_pcvar_float(duration) ) && (g_times[id] == 0) ) 
	{
		set_task(0.1, "add20",id) 
		set_task(0.2, "add19",id) 
		set_task(0.3, "add18",id) 
		set_task(0.4, "add17",id) 
		set_task(0.5, "add16",id)
		set_task(0.6, "add15",id) 
		set_task(0.7, "add14",id) 
		set_task(0.8, "add13",id) 
		set_task(0.9, "add12",id) 
		set_task(1.0, "add11",id)
		set_task(1.1, "add10",id) 
		set_task(1.2, "add9",id) 
		set_task(1.3, "add8",id)
		set_task(1.4, "add7",id)
		set_task(1.5, "add6",id)
		set_task(1.6, "add4",id)
		set_task(1.7, "add3",id)
		set_task(1.8, "add2",id)
		set_task(1.9, "add1",id)
		set_task(2.0, "add0",id)
		g_add_kill[id] = 0
		g_times[id]++ 
	}
	if ((g_add_kill[id] == 6) && (get_gametime() - time5[id] > get_pcvar_float(duration) ) && (g_times[id] == 0) ) 
	{
		set_task(0.1, "add24",id) 
		set_task(0.2, "add23",id) 
		set_task(0.3, "add22",id) 
		set_task(0.4, "add21",id) 
		set_task(0.5, "add20",id)
		set_task(0.6, "add19",id) 
		set_task(0.7, "add18",id) 
		set_task(0.8, "add17",id) 
		set_task(0.9, "add16",id) 
		set_task(1.0, "add15",id)
		set_task(1.1, "add14",id) 
		set_task(1.2, "add13",id) 
		set_task(1.3, "add12",id)
		set_task(1.4, "add11",id)
		set_task(1.5, "add10",id)
		set_task(1.6, "add9",id)
		set_task(1.7, "add8",id)
		set_task(1.8, "add7",id)
		set_task(1.9, "add6",id)
		set_task(2.0, "add5",id)
		set_task(2.1, "add4",id)
		set_task(2.2, "add3",id)
		set_task(2.3, "add2",id)
		set_task(2.4, "add1",id)
		set_task(2.5, "add0",id)
		g_add_kill[id] = 0
		g_times[id]++ 
	}
	if ((g_add_kill[id] == 7) && (get_gametime() - time6[id] > get_pcvar_float(duration) ) && (g_times[id] == 0) ) 
	{
		set_task(0.1, "add28",id) 
		set_task(0.2, "add27",id) 
		set_task(0.3, "add26",id) 
		set_task(0.4, "add25",id) 
		set_task(0.5, "add24",id)
		set_task(0.6, "add23",id) 
		set_task(0.7, "add22",id) 
		set_task(0.8, "add21",id) 
		set_task(0.9, "add20",id) 
		set_task(1.0, "add19",id)
		set_task(1.1, "add18",id) 
		set_task(1.2, "add17",id) 
		set_task(1.3, "add16",id)
		set_task(1.4, "add15",id)
		set_task(1.5, "add14",id)
		set_task(1.6, "add13",id)
		set_task(1.7, "add12",id)
		set_task(1.8, "add11",id)
		set_task(1.9, "add10",id)
		set_task(2.0, "add9",id)
		set_task(2.1, "add8",id)
		set_task(2.2, "add7",id)
		set_task(2.3, "add6",id)
		set_task(2.4, "add5",id)
		set_task(2.5, "add4",id)
		set_task(2.6, "add3",id)
		set_task(2.7, "add2",id)
		set_task(2.8, "add1",id)
		set_task(2.9, "add0",id)
		g_add_kill[id] = 0
		g_times[id]++ 
	}
}
public add0(id) 
{
	hud(id)
	show_hudmessage(id, "0/8 Kills ^n[................................] 0%%") 
}
public add1(id) 
{
	hud(id)
	show_hudmessage(id, "1/8 Kills ^n[|...............................] 3%%") 
}
public add2(id) 
{
	hud(id)
	show_hudmessage(id, "1/8 Kills ^n[||..............................] 6%%") 
}
public add3(id) 
{
	hud(id)
	show_hudmessage(id, "1/8 Kills ^n[|||.............................] 9%%") 
}
public add4(id) 
{
	hud(id)
	show_hudmessage(id, "1/8 Kills ^n[||||............................] 12%%") 
}
public add5(id) 
{
	hud(id)
	show_hudmessage(id, "2/8 Kills ^n[|||||...........................] 15%%") 
}
public add6(id) 
{
	hud(id)
	show_hudmessage(id, "2/8 Kills ^n[||||||.......................... ] 18%%") 
}
public add7(id) 
{
	hud(id)
	show_hudmessage(id, "2/8 Kills ^n[|||||||.........................] 21%%") 
}
public add8(id) 
{
	hud(id)
	show_hudmessage(id, "2/8 Kills ^n[||||||||........................] 25%%") 
}
public add9(id) 
{
	hud(id)
	show_hudmessage(id, "3/8 Kills ^n[|||||||||.......................] 28%%") 
}
public add10(id) 
{
	hud(id)
	show_hudmessage(id, "3/8 Kills ^n[||||||||||......................] 31%%") 
}
public add11(id) 
{
	hud(id)
	show_hudmessage(id, "3/8 Kills ^n[|||||||||||.....................] 34%%") 
}
public add12(id) 
{
	hud(id)
	show_hudmessage(id, "3/8 Kills ^n[||||||||||||....................] 37%%") 
}
public add13(id) 
{
	hud(id)
	show_hudmessage(id, "4/8 Kills ^n[|||||||||||||...................] 40%%") 
}
public add14(id) 
{
	hud(id)
	show_hudmessage(id, "4/8 Kills ^n[||||||||||||||..................] 43%%") 
}
public add15(id) 
{
	hud(id)
	show_hudmessage(id, "4/8 Kills ^n[|||||||||||||||.................] 46%%") 
}
public add16(id) 
{
	hud(id)
	show_hudmessage(id, "4/8 Kills ^n[||||||||||||||||................] 50%%") 
}
public add17(id) 
{
	hud(id)
	show_hudmessage(id, "5/8 Kills ^n[|||||||||||||||||...............] 53%%") 
}
public add18(id) 
{
	hud(id)
	show_hudmessage(id, "5/8 Kills ^n[||||||||||||||||||..............] 56%%") 
}
public add19(id) 
{
	hud(id)
	show_hudmessage(id, "5/8 Kills ^n[|||||||||||||||||||.............] 59%%") 
}
public add20(id) 
{
	hud(id)
	show_hudmessage(id, "5/8 Kills ^n[||||||||||||||||||||............] 62%%") 
}
public add21(id) 
{
	hud(id)
	show_hudmessage(id, "6/8 Kills ^n[|||||||||||||||||||||...........] 65%%") 
}
public add22(id) 
{
	hud(id)
	show_hudmessage(id, "6/8 Kills ^n[||||||||||||||||||||||..........] 68%%") 
}
public add23(id) 
{
	hud(id)
	show_hudmessage(id, "6/8 Kills ^n[|||||||||||||||||||||||.........] 71%%") 
}
public add24(id) 
{
	hud(id)
	show_hudmessage(id, "6/8 Kills ^n[||||||||||||||||||||||||........] 75%%") 
}
public add25(id) 
{
	hud(id)
	show_hudmessage(id, "7/8 Kills ^n[|||||||||||||||||||||||||.......] 78%%") 
}
public add26(id) 
{
	hud(id)
	show_hudmessage(id, "7/8 Kills ^n[||||||||||||||||||||||||||......] 81%%") 
}
public add27(id) 
{
	hud(id)
	show_hudmessage(id, "7/8 Kills ^n[|||||||||||||||||||||||||||.....] 84%%") 
}
public add28(id) 
{
	hud(id)
	show_hudmessage(id, "7/8 Kills ^n[||||||||||||||||||||||||||||....] 87%%") 
}
public add29(id) 
{
	hud(id)
	show_hudmessage(id, "8/8 Kills ^n[|||||||||||||||||||||||||||||...] 90%%") 
}
public add30(id) 
{
	hud(id)
	show_hudmessage(id, "8/8 Kills ^n[||||||||||||||||||||||||||||||..] 93%%") 
}
public add31(id) 
{
	hud(id)
	show_hudmessage(id, "8/8 Kills ^n[|||||||||||||||||||||||||||||||.] 96%%") 
}
public add32(id) 
{
	set_hudmessage(0, 0, 255, get_pcvar_float(x), get_pcvar_float(y), 1, _, 20.0)
	show_hudmessage(id, "8/8 Kills ^n[||||||||||||||||||||||||||||||||] 100%%^n Progress completed ^n you have won %d ammo packs", get_pcvar_num(ammo_packs)) 
	client_print(id, print_chat, "[ZP] You have won %d ammo packs for completing the progress", get_pcvar_num(ammo_packs)) 
	engfunc(EngFunc_EmitSound, id, CHAN_ITEM, complete_progress_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	zp_set_user_ammo_packs(id, (zp_get_user_ammo_packs(id) + get_pcvar_num(ammo_packs)))
}	
public hud(id) 
{
	set_hudmessage(255, 0, 0, get_pcvar_float(x), get_pcvar_float(y), 0, _, 300.0)
}
	
